/*
 * Copyright (c) 2009 Silvia Ramis, Marta Ramis
 * Copyright (c) 2016 Jose-Luis Lisani <joseluis.lisani@uib.es>
 * Copyright (c) 2019 Jose-Luis Lisani <joseluis.lisani@uib.es>
 * All rights reserved.
 *
 * This code was originally written by Silvia Ramis and Marta Ramis
 * for their Final Project on Computer Sciences Engineering (2009)
 * under the supervision of J.L. Lisani
 * Some parts of the code were written by J.L. Lisani
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


/****
This code is associated with the following publication

J.L. Lisani, S. Ramis, 
A contrario detection of faces with a short cascade of classifiers
Image Processing On Line (IPOL), 2019
****/

	
//Table of cumulated probabilities for the Standard Gaussian distribution N(0,1)
//cumZabove(s)=1-Fz(s): cumulated probability of values above s (obtained with R as: pnorm(-s))
double cumZabove[121];
void initcumZabove() {
    cumZabove[0]=2.275013e-02; //s=2.0
    cumZabove[1]=2.018222e-02;
    cumZabove[2]=1.786442e-02; //s=2.1
    cumZabove[3]=1.577761e-02;
    cumZabove[4]=1.390345e-02; //s=2.2
    cumZabove[5]=1.222447e-02;
    cumZabove[6]=1.072411e-02; //s=2.3
    cumZabove[7]=9.386706e-03;
    cumZabove[8]=8.197536e-03; //s=2.4
    cumZabove[9]=7.142811e-03;
    cumZabove[10]=6.209665e-03; //s=2.5
    cumZabove[11]=5.386146e-03;
    cumZabove[12]=4.661188e-03; //s=2.6
    cumZabove[13]=4.024589e-03;
    cumZabove[14]=3.466974e-03; //s=2.7
    cumZabove[15]=2.979763e-03;
    cumZabove[16]=2.555130e-03; //s=2.8
    cumZabove[17]=2.185961e-03;
    cumZabove[18]=1.865813e-03; //s=2.9
    cumZabove[19]=1.588870e-03;
    cumZabove[20]=1.349898e-03; //s=3.0
    cumZabove[21]=1.144207e-03;
    cumZabove[22]=9.676032e-04; //s=3.1
    cumZabove[23]=8.163523e-04;
    cumZabove[24]=6.871379e-04; //s=3.2
    cumZabove[25]=5.770250e-04;
    cumZabove[26]=4.834241e-04; //s=3.3
    cumZabove[27]=4.040578e-04;
    cumZabove[28]=3.369293e-04; //s=3.4
    cumZabove[29]=2.802933e-04;
    cumZabove[30]=2.326291e-04; //s=3.5
    cumZabove[31]=1.926156e-04;
    cumZabove[32]=1.591086e-04; //s=3.6
    cumZabove[33]=1.311202e-04;
    cumZabove[34]=1.077997e-04; //s=3.7
    cumZabove[35]=8.841729e-05;
    cumZabove[36]=7.234804e-05; //s=3.8
    cumZabove[37]=5.905891e-05;
    cumZabove[38]=4.809634e-05; //s=3.9
    cumZabove[39]=3.907560e-05;
    cumZabove[40]=3.167124e-05; //s=4.0
    cumZabove[41]=2.560882e-05;
    cumZabove[42]=2.065751e-05; //s=4.1
    cumZabove[43]=1.662376e-05;
    cumZabove[44]=1.334575e-05; //s=4.2
    cumZabove[45]=1.068853e-05;
    cumZabove[46]=8.539905e-06; //s=4.3
    cumZabove[47]=6.806877e-06;
    cumZabove[48]=5.412544e-06; //s=4.4
    cumZabove[49]=4.293514e-06;
    cumZabove[50]=3.397673e-06; //s=4.5
    cumZabove[51]=2.682296e-06;
    cumZabove[52]=2.112455e-06; //s=4.6
    cumZabove[53]=1.659675e-06;
    cumZabove[54]=1.300807e-06; //s=4.7
    cumZabove[55]=1.017083e-06;
    cumZabove[56]=7.933282e-07; //s=4.8
    cumZabove[57]=6.173074e-07;
    cumZabove[58]=4.791833e-07; //s=4.9
    cumZabove[59]=3.710674e-07;
    cumZabove[60]=2.866516e-07; //s=5.0
    cumZabove[61]=2.209050e-07;
    cumZabove[62]=1.698267e-07; //s=5.1
    cumZabove[63]=1.302432e-07;
    cumZabove[64]=9.964426e-08; //s=5.2
    cumZabove[65]=7.604961e-08;
    cumZabove[66]=5.790134e-08; //s=5.3
    cumZabove[67]=4.397712e-08;
    cumZabove[68]=3.332045e-08; //s=5.4
    cumZabove[69]=2.518491e-08;
    cumZabove[70]=1.898956e-08; //s=5.5
    cumZabove[71]=1.428348e-08;
    cumZabove[72]=1.071759e-08; //s=5.6
    cumZabove[73]=8.022392e-09;
    cumZabove[74]=5.990371e-09; //s=5.7
    cumZabove[75]=4.462172e-09;
    cumZabove[76]=3.315746e-09; //s=5.8
    cumZabove[77]=2.457865e-09;
    cumZabove[78]=1.817508e-09; //s=5.9
    cumZabove[79]=1.340712e-09;
    cumZabove[80]=9.865876e-10; //s=6.0
    cumZabove[81]=7.242292e-10;
    cumZabove[82]=5.303423e-10; //s=6.1
    cumZabove[83]=3.874147e-10;
    cumZabove[84]=2.823158e-10; //s=6.2
    cumZabove[85]=2.052263e-10;
    cumZabove[86]=1.488228e-10; //s=6.3
    cumZabove[87]=1.076575e-10;
    cumZabove[88]=7.768847e-11; //s=6.4
    cumZabove[89]=5.592507e-11;
    cumZabove[90]=4.016000e-11; //s=6.5
    cumZabove[91]=2.876854e-11;
    cumZabove[92]=2.055789e-11; //s=6.6
    cumZabove[93]=1.465465e-11;
    cumZabove[94]=1.042098e-11; //s=6.7
    cumZabove[95]=7.392258e-12;
    cumZabove[96]=5.230957e-12; //s=6.8
    cumZabove[97]=3.692499e-12;
    cumZabove[98]=2.600127e-12; //s=6.9
    cumZabove[99]=1.826431e-12;
    cumZabove[100]=1.279812e-12; //s=7.0
    cumZabove[101]=8.945889e-13;
    cumZabove[102]=6.237844e-13; //s=7.1
    cumZabove[103]=4.338895e-13;
    cumZabove[104]=3.010628e-13; //s=7.2
    cumZabove[105]=2.083858e-13;
    cumZabove[106]=1.438839e-13; //s=7.3
    cumZabove[107]=9.910343e-14;
    cumZabove[108]=6.809225e-14; //s=7.4
    cumZabove[109]=4.667011e-14;
    cumZabove[110]=3.190892e-14; //s=7.5
    cumZabove[111]=2.176291e-14;
    cumZabove[112]=1.480654e-14; //s=7.6
    cumZabove[113]=1.004896e-14;
    cumZabove[114]=6.803311e-15; //s=7.7
    cumZabove[115]=4.594627e-15;
    cumZabove[116]=3.095359e-15; //s=7.8
    cumZabove[117]=2.080186e-15;
    cumZabove[118]=1.394517e-15; //s=7.9
    cumZabove[119]=9.325576e-16;
    cumZabove[120]=6.220960e-16; //s=8.0
    
    
}

//Function to compute the value of z such that P(Z > z)=a, 
//where Z is the standard Gaussian distribution with 0 mean and
//unit variance and a is an input parameter distribution function

//This function is needed to compute the detection thresholds of the
//face classifiers and it is called in lines 9 and 12 of Algorithm 2,
//as described in the associated IPOL publication


double invcumZabove(double p)
{
    initcumZabove();
    int n=0;
    double s=2.0;
    while ((n <= 120) && (cumZabove[n] > p)) {
        s+=0.05;
        n++;
    }
    return s;
}


