/*
 * Copyright (c) 2009 Silvia Ramis, Marta Ramis
 * Copyright (c) 2016 Jose-Luis Lisani <joseluis.lisani@uib.es>
 * Copyright (c) 2019 Jose-Luis Lisani <joseluis.lisani@uib.es>
 * All rights reserved.
 *
 * This code was originally written by Silvia Ramis and Marta Ramis
 * for their Final Project on Computer Sciences Engineering (2009)
 * under the supervision of J.L. Lisani
 * Some parts of the code were written by J.L. Lisani
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LIB_FACEDET_H
#define LIB_FACEDET_H

//Face detection function
//Input arguments:
//  - name of input image
//  - name of first classifier
//  - name of second classifier
//  - name of third classifier
//  - name of fourth classifier
//  - minimum size of detected faces
//  - maximum size of detected faces
//  - size increase factor from minimum to maximum size
//  - percentage of detections kept by 1st classifier
//  - percentage of detections kept by 2nd classifier
//  - maximum number of false positives allowed by 3rd classifier
//  - maximum number of false positives allowed by 4th classifier
//    = maximum number of false positives at the detector's output
void detectfaces(const char *namein,
                  const char *nameclass1,
                  const char *nameclass2,
                  const char *nameclass3,
                  const char *nameclass4,
                  const char *nameout,
                  int minSize,
                  int maxSize,
                  float stepZoom,
                  float prc1,
                  float prc2,
                  float nfa1,
                  float nfa2);


#endif



