/*
 * Copyright (c) 2009 Silvia Ramis, Marta Ramis
 * Copyright (c) 2013 Jose-Luis Lisani <joseluis.lisani@uib.es>
 * All rights reserved.
 *
 * This code was originally written by Silvia Ramis and Marta Ramis
 * for their Final Project on Computer Sciences Engineering (2009)
 * under the supervision of J.L. Lisani
 * Some parts of the code were written by J.L. Lisani
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>
#include <string.h>

//zoom input image
void zoom_image(unsigned char *in, unsigned char *out,
                int width, int height,
                float zoom, int new_width, int new_height);
                
//zoom input image
//create output image
unsigned char *zoom_image(unsigned char *in, int width, int height,
                          float zoom, int &new_width, int &new_height);
                          
//mirror version of input image
//create output image
unsigned char *mirror_image(unsigned char *in, int width, int height);
                          
                
//get subimage from I
//top-left corner: (Tx, Ty)
//bottom-right corner: (Tx+wsub-1, Ty+hsub-1)
void getsubimage(unsigned char *I, unsigned char *Isub, 
                 int Tx, int Ty, int w, int wsub, int hsub);

//compute percentage of intersecion area between two rectangles
float check_superposition_rectangles(int x1_a, int y1_a, int x2_a, int y2_a,
                                     int x1_b, int y1_b, int x2_b, int y2_b);
                                     

//Draw rectangle in image, with gray value 'grey'
//Top-left corner: (x1, y1)
//Bottom-right corner: (x2, y2)
void drawRectangleGrey(unsigned char *out, int width, int height, 
                       int x1, int y1, int x2, int y2, unsigned char grey);


